{
  This unit contains a stringgrid (DataPointGrid) to retrieve data points at run time.

  If there's request for it, I'll expand this unit so it works almost like the stringgrids
  in spreadsheet programs like MS Excel and Lotus 1-2-3.

  User may do with this code whatever (s)he wants.

  Author: John Merrit (John.Merrit@NET4ALL.BE) }

unit DPointD;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TDataPointDialog = class(TForm)
    DataPointGrid: TStringGrid;
    DimensionEdit: TEdit;
    Label1: TLabel;
    Button1: TButton;
    procedure DimensionEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DataPointGridSetEditText(Sender: TObject; ACol,
      ARow: Longint; const Value: string);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure UpdateDataPointGrid;
  public
    { Public declarations }
  end;

var
  DataPointDialog: TDataPointDialog;

implementation

{$R *.DFM}

procedure TDataPointDialog.DimensionEditChange(Sender: TObject);
var i: integer;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if DimensionEdit.Text <> '' then
      begin
      try
      i:= StrToInt(DimensionEdit.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if ((ErrorOc = true) or (i <= 0)) then
      begin
      MessageDlg('Invalid number of data points!', mtError,[mbOk], 0);
      DimensionEdit.Text:= '3';
      end
      else
      begin
      DataPointGrid.ColCount:= i + 1;
      UpdateDataPointGrid;
      end;
      end;

end;

procedure TDataPointDialog.UpdateDataPointGrid;
var i, j: integer;
begin
     with DataPointGrid do
     begin
       for i:= 1 to ColCount - 1 do
       for j:= 1 to RowCount - 1 do
       Cells[i,j]:= '0';
       for j:= 1 to RowCount - 1 do
       Cells[0,j]:= 'StatVector ' + IntToStr(j);
       for i:= 1 to ColCount - 1 do
       Cells[i,0]:= 'Data Point ' + IntToStr(i);
     end
end;



procedure TDataPointDialog.FormCreate(Sender: TObject);
begin
     UpdateDataPointGrid;
     DataPointGrid.Options:= [goEditing, goAlwaysShowEditor, goVertLine, goHorzLine, goTabs];
end;

procedure TDataPointDialog.DataPointGridSetEditText(Sender: TObject; ACol,
  ARow: Longint; const Value: string);
var i: extended;
begin
     if ((Value <> '') and (Value <> '-')) then
     begin
     try
     i:= StrToFloat(Value);
     except on EConvertError do
     begin
     MessageDlg('''' + Value + '''' + ' is not a valid floating point number!', mtError,[mbOk], 0);
     DataPointGrid.Cells[ACol,ARow]:= '0';
     end;
     end;
     end;
end;

procedure TDataPointDialog.Button1Click(Sender: TObject);
begin
     Close;
end;

procedure TDataPointDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
var i, j: integer;
begin
     with DataPointGrid do
     begin
       for i:= 1 to ColCount - 1 do
       for j:= 1 to RowCount - 1 do
       begin
        if Cells[i,j] = '' then Cells[i,j]:= '0';
       end;
     end;
end;

end.
